# Dapr 1.7.3

### Fixes incorrect actor state-store configuration behavior

#### Problem

All Actor APIs return errors without an actor state store component being provided. This is the correct behavior for services that register actors, as they require state storage, but clients that invoke actors should operate with or without an actor state store. 

#### Root cause

The code that initializes the Actor API raises an error when there is no actor state storage component available, regardless of whether or not the service
registers actors. 

#### Solution

Thix fix changes the actor runtime initialization logic such that, when there is no actor state store available, the API will initialize correctly as long as the service does not register actors. As a result, the Actor API will be available to services acting only as clients (i.e invoking actors) with or without an actor state store component; the Actor API will continue to be unavailable in those services that register actors without providing an actor state store component.